
/* 
 * File:   demoConst26.c
 * Author: Nathan
 *
 * Created on 15. January 2016, 20:25
 */
#define _SUPPRESS_PLIB_WARNING
#define _DISABLE_OPENADC10_CONFIGPORT_WARNING

#include <xc.h>			   // Required for SFR defs
#include <sys/attribs.h>   // Required to use __longramfunc__
						   // and __ramfunc__ macros.
#include  "CFunctions.h"

//
// make some address calculations to get the flash position of the actual
// function. This should be possible by fp pointer, too.
// I do not trust the fp, lets use the ra register instead
// (a) is point to function, (b) pointer to label, (c) pointer for result
// if a is set to NULL the offset will be output, use full for static const calculation.
// 

 __attribute__((noinline)) void getFPC(void *a, void *b, volatile unsigned int *c)
     {
         *c = (unsigned int) (__builtin_return_address (0) - (b -a)) ;     
     }
 
 void main(long long *_iii, long long *_ii) {

 //keep the following lines together, lableAdr will contains address of main
 //if used within an other function, please adapt main -> function name
 volatile unsigned int libAddr ;
 getFPC(NULL,&&getFPCLab,&libAddr) ; // warning can be ignored, stupid editor
 getFPCLab: { }
 //
 unsigned int offs = libAddr ;
 
 // --> static const is required
 static const unsigned char asd1[] = "Hi, " ;
 static const unsigned char asd2[] = "if you can" ;
 static const unsigned char asd3[] = "read this" ;
 static const unsigned char asd4[] = "then you" ;
 static const unsigned char asd5[] = "got it running.";
 static const unsigned char asd6[] = "7";
 static const unsigned char asd7[] = "8";
 static const unsigned char asd8[] = "default";
 unsigned char *asd[] = { (unsigned char *)asd1 , (unsigned char *)asd2 , (unsigned char *)asd3 , (unsigned char *)asd4 ,
                          (unsigned char *)asd5 , (unsigned char *)asd6 , (unsigned char *)asd7 , (unsigned char *)asd8} ;
						  
 unsigned char  *_string = (unsigned char *)_ii;
 unsigned int i = 0 ;
 unsigned int iii = *_iii ;
 unsigned char  * xptr2 ;
 
 //
 // the next is required for every access of a const declaration
 // add the offset ( to adapt the different locations between cfunction in flash#
 //                  and locations during compilation/linking), manual gop
 // --> you need an address, which you can manipulate <--
 //
 if (iii >= (sizeof( asd)/sizeof(unsigned char*))) iii=(sizeof(asd)/sizeof(unsigned char*))-1;
 
 xptr2 = asd[iii] + offs;
 //
 // lets access the const data string, and copy it to the basic-ram 
 //
 for(i=1; *xptr2 && i != 256 ;i++){
   _string[i]= (unsigned char)*xptr2;
   xptr2++ ;
 }
 _string[0]= i-1 ;
}
 